<html>
<head>
<title>OGRE: Ogre::VertexAnimationTrack Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1VertexAnimationTrack.html">VertexAnimationTrack</a></div>
<h1>Ogre::VertexAnimationTrack Class Reference</h1><!-- doxytag: class="Ogre::VertexAnimationTrack" --><!-- doxytag: inherits="Ogre::AnimationTrack" -->Specialised <a class="el" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, ie a sequence of keyframes which affect...">AnimationTrack</a> for dealing with changing vertex position information.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Ogre::VertexAnimationTrack:</div>
<div class="dynsection">
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="classOgre_1_1VertexAnimationTrack-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">enum &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#8428fcdefb79b2dd650b22968a3e8134">TargetMode</a> { <a class="el" href="classOgre_1_1VertexAnimationTrack.html#8428fcdefb79b2dd650b22968a3e81342e9398cdf64d0a07033f83a3ddaadf2c">TM_SOFTWARE</a>, 
<a class="el" href="classOgre_1_1VertexAnimationTrack.html#8428fcdefb79b2dd650b22968a3e81348c5fb4696cb266eb28aa2ec029aad0c3">TM_HARDWARE</a>
 }</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The target animation mode.  <a href="classOgre_1_1VertexAnimationTrack.html#8428fcdefb79b2dd650b22968a3e8134">More...</a><br></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#06136478dc5dff67a65d50067628a24b">VertexAnimationTrack</a> (<a class="el" href="classOgre_1_1Animation.html">Animation</a> *parent, unsigned short handle, <a class="el" href="namespaceOgre.html#9046e6e0d12c46c57a9056987e9d158e">VertexAnimationType</a> animType)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Constructor.  <a href="#06136478dc5dff67a65d50067628a24b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#d608609aaa85876c7c23c298e446cdff">VertexAnimationTrack</a> (<a class="el" href="classOgre_1_1Animation.html">Animation</a> *parent, unsigned short handle, <a class="el" href="namespaceOgre.html#9046e6e0d12c46c57a9056987e9d158e">VertexAnimationType</a> animType, <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *targetData, <a class="el" href="classOgre_1_1VertexAnimationTrack.html#8428fcdefb79b2dd650b22968a3e8134">TargetMode</a> target=TM_SOFTWARE)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Constructor, associates with target <a class="el" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> and temp buffer (for software).  <a href="#d608609aaa85876c7c23c298e446cdff"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#9046e6e0d12c46c57a9056987e9d158e">VertexAnimationType</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#a2c105e1ad534cdd9938331f8eb1cae6">getAnimationType</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the type of vertex animation we're performing.  <a href="#a2c105e1ad534cdd9938331f8eb1cae6"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <br>
<a class="el" href="classOgre_1_1VertexMorphKeyFrame.html">VertexMorphKeyFrame</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#827ce0ebb406c71ef1868edf98ef58fc">createVertexMorphKeyFrame</a> (<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> timePos)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a new morph <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> and adds it to this animation at the given time index.  <a href="#827ce0ebb406c71ef1868edf98ef58fc"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <br>
<a class="el" href="classOgre_1_1VertexPoseKeyFrame.html">VertexPoseKeyFrame</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#4b0bd6098fec16a9e1083f0e36a755e9">createVertexPoseKeyFrame</a> (<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> timePos)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates the single pose <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> and adds it to this animation.  <a href="#4b0bd6098fec16a9e1083f0e36a755e9"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#971c33f7d8d93cbf93dc0ec51fb5d71d">getInterpolatedKeyFrame</a> (const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;timeIndex, <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> *kf) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method in fact does nothing, since interpolation is not performed inside the keyframes for this type of track.  <a href="#971c33f7d8d93cbf93dc0ec51fb5d71d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#142ab858538a9984b4cf2b5267fcda45">apply</a> (const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;timeIndex, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> weight=1.0, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> scale=1.0f)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Applies an animation track to the designated target. <p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>timeIndex</em>&nbsp;</td><td>The time position in the animation to apply. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>weight</em>&nbsp;</td><td>The influence to give to this track, 1.0 for full influence, less to blend with other animations. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>scale</em>&nbsp;</td><td>The scale to apply to translations and scalings, useful for adapting an animation to a different size target. </td></tr>
  </table>
</dl>
  <a href="#142ab858538a9984b4cf2b5267fcda45"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#2a0f0bf65e74c4cd3a92fd60e2e26cbe">applyToVertexData</a> (<a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *data, const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;timeIndex, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> weight=1.0, const <a class="el" href="namespaceOgre.html#8f03b49c53cbcc1d22f4ef3abfb5b1eb">PoseList</a> *poseList=0)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">As the 'apply' method but applies to specified <a class="el" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> instead of associated data.  <a href="#2a0f0bf65e74c4cd3a92fd60e2e26cbe"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1VertexMorphKeyFrame.html">VertexMorphKeyFrame</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#1c9ac9c5e75c9db77b7aad8dd7b651ab">getVertexMorphKeyFrame</a> (unsigned short index) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the morph <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at the specified index.  <a href="#1c9ac9c5e75c9db77b7aad8dd7b651ab"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1VertexPoseKeyFrame.html">VertexPoseKeyFrame</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#2e934a3d97a57275a0466c5f48281875">getVertexPoseKeyFrame</a> (unsigned short index) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the pose <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at the specified index.  <a href="#2e934a3d97a57275a0466c5f48281875"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#a37cffa57bfec055af3982f6c50c45a9">setAssociatedVertexData</a> (<a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *data)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets the associated <a class="el" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> which this track will update.  <a href="#a37cffa57bfec055af3982f6c50c45a9"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#a1c92109ea295276cb6730ba8f155a64">getAssociatedVertexData</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the associated <a class="el" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> which this track will update.  <a href="#a1c92109ea295276cb6730ba8f155a64"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#d3def6ebcacc946484a16745ba89a060">setTargetMode</a> (<a class="el" href="classOgre_1_1VertexAnimationTrack.html#8428fcdefb79b2dd650b22968a3e8134">TargetMode</a> m)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the target mode.  <a href="#d3def6ebcacc946484a16745ba89a060"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#8428fcdefb79b2dd650b22968a3e8134">TargetMode</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#9ba2ac9172215ae3abfdf2cda61da663">getTargetMode</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the target mode.  <a href="#9ba2ac9172215ae3abfdf2cda61da663"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#fa0e80d8dd451a65d89f7f9365a929e5">hasNonZeroKeyFrames</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.  <a href="#fa0e80d8dd451a65d89f7f9365a929e5"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#366c0dfa30d9b59d685ff1f7622b5ba7">optimise</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Optimise the current track by removing any duplicate keyframes.  <a href="#366c0dfa30d9b59d685ff1f7622b5ba7"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1VertexAnimationTrack.html">VertexAnimationTrack</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#1aca615eb45df1be9c57f95e6889512e">_clone</a> (<a class="el" href="classOgre_1_1Animation.html">Animation</a> *newParent) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Clone this track (internal use only).  <a href="#1aca615eb45df1be9c57f95e6889512e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned short&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#32de796f12f6afee4c93e12625535577">getHandle</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the handle associated with this track.  <a href="#32de796f12f6afee4c93e12625535577"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual unsigned short&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#e0c1160b89c7f2be74ae2962239bd732">getNumKeyFrames</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the number of keyframes in this animation.  <a href="#e0c1160b89c7f2be74ae2962239bd732"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#f27f57a984619052cca4726cdfd26f3c">getKeyFrame</a> (unsigned short index) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at the specified index.  <a href="#f27f57a984619052cca4726cdfd26f3c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#55533ed5218c6d423e9443afa2580f5a">getKeyFramesAtTime</a> (const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;timeIndex, <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> **keyFrame1, <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> **keyFrame2, unsigned short *firstKeyIndex=0) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the 2 <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> objects which are active at the time given, and the blend value between them.  <a href="#55533ed5218c6d423e9443afa2580f5a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#4517a1b16d6cb601754d98841bb4d7d6">createKeyFrame</a> (<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> timePos)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a new <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> and adds it to this animation at the given time index.  <a href="#4517a1b16d6cb601754d98841bb4d7d6"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#3e1ccd99179d804992a5224fe811c2dd">removeKeyFrame</a> (unsigned short index)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Removes a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> by it's index.  <a href="#3e1ccd99179d804992a5224fe811c2dd"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#c8f7b83d742998ed46c8cdb10e404df6">removeAllKeyFrames</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Removes all the KeyFrames from this track.  <a href="#c8f7b83d742998ed46c8cdb10e404df6"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#715b6d025247c4857a5deba9376ae48c">_keyFrameDataChanged</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data.  <a href="#715b6d025247c4857a5deba9376ae48c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#7aab09df8cf0fea5b1a53df263b9e2c1">_collectKeyFrameTimes</a> (std::vector&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; &amp;keyFrameTimes)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method to collect keyframe times, in unique, ordered format.  <a href="#7aab09df8cf0fea5b1a53df263b9e2c1"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#6f341ad134c0254f15a0cba2bbae4097">_buildKeyFrameIndexMap</a> (const std::vector&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; &amp;keyFrameTimes)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method to build keyframe time index map to translate global lower bound index to local lower bound index.  <a href="#6f341ad134c0254f15a0cba2bbae4097"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> * &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#501aac9ae307fd6813a31792404cf770">KeyFrameList</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#27b9b55f9a560e3b7c83f0d47676fc51">KeyFrameIndexMap</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Map used to translate global keyframe time lower bound index to local lower bound index.  <a href="#27b9b55f9a560e3b7c83f0d47676fc51"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#cb49f4f94c1198ba4fe955337796615d">createKeyFrameImpl</a> (<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> time)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a keyframe implementation - must be overridden.   <a href="#cb49f4f94c1198ba4fe955337796615d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#9f90733cbb7225fc7213ab01eb858d92">applyPoseToVertexData</a> (const <a class="el" href="classOgre_1_1Pose.html">Pose</a> *pose, <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *data, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> influence)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Utility method for applying pose animation.  <a href="#9f90733cbb7225fc7213ab01eb858d92"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#4e61fb2e00abd26a854d122452cb21a0">populateClone</a> (<a class="el" href="classOgre_1_1AnimationTrack.html">AnimationTrack</a> *clone) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method for clone implementation.  <a href="#4e61fb2e00abd26a854d122452cb21a0"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#9046e6e0d12c46c57a9056987e9d158e">VertexAnimationType</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#2ac916da1e92895527b816f1da170759">mAnimationType</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><a class="el" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a> type.  <a href="#2ac916da1e92895527b816f1da170759"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#146021bbee13fee93a93bd8ef913d77a">mTargetVertexData</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Target to animate.  <a href="#146021bbee13fee93a93bd8ef913d77a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#8428fcdefb79b2dd650b22968a3e8134">TargetMode</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#719e33971eaf3ae6b4f9bc603c94595c">mTargetMode</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Mode to apply.  <a href="#719e33971eaf3ae6b4f9bc603c94595c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1AnimationTrack.html#501aac9ae307fd6813a31792404cf770">KeyFrameList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#8a9bee08f6fa537fc0bcfcee2423775c">mKeyFrames</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Animation.html">Animation</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#ea479089005d263e195cde7e4faca665">mParent</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned short&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#5fb5dc3c01452aa4d542981485d15080">mHandle</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1AnimationTrack.html#27b9b55f9a560e3b7c83f0d47676fc51">KeyFrameIndexMap</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#2c053bac1d2eedc782eb24b79dc79a21">mKeyFrameIndexMap</a></td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Specialised <a class="el" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, ie a sequence of keyframes which affect...">AnimationTrack</a> for dealing with changing vertex position information. 
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="namespaceOgre.html#9046e6e0d12c46c57a9056987e9d158e" title="Type of vertex animation.">VertexAnimationType</a> </dd></dl>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00452">452</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>
<hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="501aac9ae307fd6813a31792404cf770"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::KeyFrameList" ref="501aac9ae307fd6813a31792404cf770" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a>*&gt; <a class="el" href="classOgre_1_1AnimationTrack.html#501aac9ae307fd6813a31792404cf770">Ogre::AnimationTrack::KeyFrameList</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00216">216</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="27b9b55f9a560e3b7c83f0d47676fc51"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::KeyFrameIndexMap" ref="27b9b55f9a560e3b7c83f0d47676fc51" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a>&gt; <a class="el" href="classOgre_1_1AnimationTrack.html#27b9b55f9a560e3b7c83f0d47676fc51">Ogre::AnimationTrack::KeyFrameIndexMap</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Map used to translate global keyframe time lower bound index to local lower bound index. 
<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00222">222</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Enumeration Documentation</h2>
<a class="anchor" name="8428fcdefb79b2dd650b22968a3e8134"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::TargetMode" ref="8428fcdefb79b2dd650b22968a3e8134" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classOgre_1_1VertexAnimationTrack.html#8428fcdefb79b2dd650b22968a3e8134">Ogre::VertexAnimationTrack::TargetMode</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
The target animation mode. 
<p>
<dl compact><dt><b>Enumerator: </b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" name="8428fcdefb79b2dd650b22968a3e81342e9398cdf64d0a07033f83a3ddaadf2c"></a><!-- doxytag: member="TM_SOFTWARE" ref="8428fcdefb79b2dd650b22968a3e81342e9398cdf64d0a07033f83a3ddaadf2c" args="" -->TM_SOFTWARE</em>&nbsp;</td><td>
Interpolate vertex positions in software. </td></tr>
<tr><td valign="top"><em><a class="anchor" name="8428fcdefb79b2dd650b22968a3e81348c5fb4696cb266eb28aa2ec029aad0c3"></a><!-- doxytag: member="TM_HARDWARE" ref="8428fcdefb79b2dd650b22968a3e81348c5fb4696cb266eb28aa2ec029aad0c3" args="" -->TM_HARDWARE</em>&nbsp;</td><td>
Bind keyframe 1 to position, and keyframe 2 to a texture coordinate for interpolation in hardware. </td></tr>
</table>
</dl>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00456">456</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="06136478dc5dff67a65d50067628a24b"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::VertexAnimationTrack" ref="06136478dc5dff67a65d50067628a24b" args="(Animation *parent, unsigned short handle, VertexAnimationType animType)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::VertexAnimationTrack::VertexAnimationTrack           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Animation.html">Animation</a> *&nbsp;</td>
          <td class="paramname"> <em>parent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>handle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#9046e6e0d12c46c57a9056987e9d158e">VertexAnimationType</a>&nbsp;</td>
          <td class="paramname"> <em>animType</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Constructor. 
<p>

</div>
</div><p>
<a class="anchor" name="d608609aaa85876c7c23c298e446cdff"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::VertexAnimationTrack" ref="d608609aaa85876c7c23c298e446cdff" args="(Animation *parent, unsigned short handle, VertexAnimationType animType, VertexData *targetData, TargetMode target=TM_SOFTWARE)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::VertexAnimationTrack::VertexAnimationTrack           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Animation.html">Animation</a> *&nbsp;</td>
          <td class="paramname"> <em>parent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>handle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#9046e6e0d12c46c57a9056987e9d158e">VertexAnimationType</a>&nbsp;</td>
          <td class="paramname"> <em>animType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&nbsp;</td>
          <td class="paramname"> <em>targetData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#8428fcdefb79b2dd650b22968a3e8134">TargetMode</a>&nbsp;</td>
          <td class="paramname"> <em>target</em> = <code>TM_SOFTWARE</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Constructor, associates with target <a class="el" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> and temp buffer (for software). 
<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="a2c105e1ad534cdd9938331f8eb1cae6"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::getAnimationType" ref="a2c105e1ad534cdd9938331f8eb1cae6" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#9046e6e0d12c46c57a9056987e9d158e">VertexAnimationType</a> Ogre::VertexAnimationTrack::getAnimationType           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get the type of vertex animation we're performing. 
<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00471">471</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="827ce0ebb406c71ef1868edf98ef58fc"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::createVertexMorphKeyFrame" ref="827ce0ebb406c71ef1868edf98ef58fc" args="(Real timePos)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1VertexMorphKeyFrame.html">VertexMorphKeyFrame</a>* Ogre::VertexAnimationTrack::createVertexMorphKeyFrame           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>timePos</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a new morph <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> and adds it to this animation at the given time index. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>It is better to create KeyFrames in time order. Creating them out of order can result in expensive reordering processing. Note that a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at time index 0.0 is always created for you, so you don't need to create this one, just access it using getKeyFrame(0); </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>timePos</em>&nbsp;</td><td>The time from which this <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> will apply. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="4b0bd6098fec16a9e1083f0e36a755e9"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::createVertexPoseKeyFrame" ref="4b0bd6098fec16a9e1083f0e36a755e9" args="(Real timePos)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1VertexPoseKeyFrame.html">VertexPoseKeyFrame</a>* Ogre::VertexAnimationTrack::createVertexPoseKeyFrame           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>timePos</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates the single pose <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> and adds it to this animation. 
<p>

</div>
</div><p>
<a class="anchor" name="971c33f7d8d93cbf93dc0ec51fb5d71d"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::getInterpolatedKeyFrame" ref="971c33f7d8d93cbf93dc0ec51fb5d71d" args="(const TimeIndex &amp;timeIndex, KeyFrame *kf) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::VertexAnimationTrack::getInterpolatedKeyFrame           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>timeIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>kf</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
This method in fact does nothing, since interpolation is not performed inside the keyframes for this type of track. 
<p>

<p>Implements <a class="el" href="classOgre_1_1AnimationTrack.html#48a8e96d4cb65f050dfed427f4442aa4">Ogre::AnimationTrack</a>.</p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00489">489</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="142ab858538a9984b4cf2b5267fcda45"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::apply" ref="142ab858538a9984b4cf2b5267fcda45" args="(const TimeIndex &amp;timeIndex, Real weight=1.0, Real scale=1.0f)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::VertexAnimationTrack::apply           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>timeIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>weight</em> = <code>1.0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>scale</em> = <code>1.0f</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Applies an animation track to the designated target. <p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>timeIndex</em>&nbsp;</td><td>The time position in the animation to apply. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>weight</em>&nbsp;</td><td>The influence to give to this track, 1.0 for full influence, less to blend with other animations. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>scale</em>&nbsp;</td><td>The scale to apply to translations and scalings, useful for adapting an animation to a different size target. </td></tr>
  </table>
</dl>
 
<p>

<p>Implements <a class="el" href="classOgre_1_1AnimationTrack.html#a32b2807aee58478f96e75bfa44141cc">Ogre::AnimationTrack</a>.</p>

</div>
</div><p>
<a class="anchor" name="2a0f0bf65e74c4cd3a92fd60e2e26cbe"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::applyToVertexData" ref="2a0f0bf65e74c4cd3a92fd60e2e26cbe" args="(VertexData *data, const TimeIndex &amp;timeIndex, Real weight=1.0, const PoseList *poseList=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::VertexAnimationTrack::applyToVertexData           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&nbsp;</td>
          <td class="paramname"> <em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>timeIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>weight</em> = <code>1.0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#8f03b49c53cbcc1d22f4ef3abfb5b1eb">PoseList</a> *&nbsp;</td>
          <td class="paramname"> <em>poseList</em> = <code>0</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
As the 'apply' method but applies to specified <a class="el" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> instead of associated data. 
<p>

</div>
</div><p>
<a class="anchor" name="1c9ac9c5e75c9db77b7aad8dd7b651ab"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::getVertexMorphKeyFrame" ref="1c9ac9c5e75c9db77b7aad8dd7b651ab" args="(unsigned short index) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexMorphKeyFrame.html">VertexMorphKeyFrame</a>* Ogre::VertexAnimationTrack::getVertexMorphKeyFrame           </td>
          <td>(</td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>index</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the morph <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at the specified index. 
<p>

</div>
</div><p>
<a class="anchor" name="2e934a3d97a57275a0466c5f48281875"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::getVertexPoseKeyFrame" ref="2e934a3d97a57275a0466c5f48281875" args="(unsigned short index) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexPoseKeyFrame.html">VertexPoseKeyFrame</a>* Ogre::VertexAnimationTrack::getVertexPoseKeyFrame           </td>
          <td>(</td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>index</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the pose <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at the specified index. 
<p>

</div>
</div><p>
<a class="anchor" name="a37cffa57bfec055af3982f6c50c45a9"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::setAssociatedVertexData" ref="a37cffa57bfec055af3982f6c50c45a9" args="(VertexData *data)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::VertexAnimationTrack::setAssociatedVertexData           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&nbsp;</td>
          <td class="paramname"> <em>data</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sets the associated <a class="el" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> which this track will update. 
<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00508">508</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="a1c92109ea295276cb6730ba8f155a64"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::getAssociatedVertexData" ref="a1c92109ea295276cb6730ba8f155a64" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a>* Ogre::VertexAnimationTrack::getAssociatedVertexData           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the associated <a class="el" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> which this track will update. 
<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00510">510</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="d3def6ebcacc946484a16745ba89a060"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::setTargetMode" ref="d3def6ebcacc946484a16745ba89a060" args="(TargetMode m)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::VertexAnimationTrack::setTargetMode           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#8428fcdefb79b2dd650b22968a3e8134">TargetMode</a>&nbsp;</td>
          <td class="paramname"> <em>m</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Set the target mode. 
<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00513">513</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="9ba2ac9172215ae3abfdf2cda61da663"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::getTargetMode" ref="9ba2ac9172215ae3abfdf2cda61da663" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#8428fcdefb79b2dd650b22968a3e8134">TargetMode</a> Ogre::VertexAnimationTrack::getTargetMode           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get the target mode. 
<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00515">515</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="fa0e80d8dd451a65d89f7f9365a929e5"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::hasNonZeroKeyFrames" ref="fa0e80d8dd451a65d89f7f9365a929e5" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Ogre::VertexAnimationTrack::hasNonZeroKeyFrames           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out. 
<p>

<p>Reimplemented from <a class="el" href="classOgre_1_1AnimationTrack.html#3a07b2082c15608cc24be21e2b6bb822">Ogre::AnimationTrack</a>.</p>

</div>
</div><p>
<a class="anchor" name="366c0dfa30d9b59d685ff1f7622b5ba7"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::optimise" ref="366c0dfa30d9b59d685ff1f7622b5ba7" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::VertexAnimationTrack::optimise           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Optimise the current track by removing any duplicate keyframes. 
<p>

<p>Reimplemented from <a class="el" href="classOgre_1_1AnimationTrack.html#d96281be1b189c69a1dbd2283d583503">Ogre::AnimationTrack</a>.</p>

</div>
</div><p>
<a class="anchor" name="1aca615eb45df1be9c57f95e6889512e"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::_clone" ref="1aca615eb45df1be9c57f95e6889512e" args="(Animation *newParent) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexAnimationTrack.html">VertexAnimationTrack</a>* Ogre::VertexAnimationTrack::_clone           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Animation.html">Animation</a> *&nbsp;</td>
          <td class="paramname"> <em>newParent</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Clone this track (internal use only). 
<p>

</div>
</div><p>
<a class="anchor" name="cb49f4f94c1198ba4fe955337796615d"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::createKeyFrameImpl" ref="cb49f4f94c1198ba4fe955337796615d" args="(Real time)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a>* Ogre::VertexAnimationTrack::createKeyFrameImpl           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>time</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Create a keyframe implementation - must be overridden.  
<p>

<p>Implements <a class="el" href="classOgre_1_1AnimationTrack.html#a344f22d2582a0adacea56bf7b6dcd7d">Ogre::AnimationTrack</a>.</p>

</div>
</div><p>
<a class="anchor" name="9f90733cbb7225fc7213ab01eb858d92"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::applyPoseToVertexData" ref="9f90733cbb7225fc7213ab01eb858d92" args="(const Pose *pose, VertexData *data, Real influence)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::VertexAnimationTrack::applyPoseToVertexData           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Pose.html">Pose</a> *&nbsp;</td>
          <td class="paramname"> <em>pose</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&nbsp;</td>
          <td class="paramname"> <em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>influence</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Utility method for applying pose animation. 
<p>

</div>
</div><p>
<a class="anchor" name="32de796f12f6afee4c93e12625535577"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::getHandle" ref="32de796f12f6afee4c93e12625535577" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned short Ogre::AnimationTrack::getHandle           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get the handle associated with this track. 
<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00125">125</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="e0c1160b89c7f2be74ae2962239bd732"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::getNumKeyFrames" ref="e0c1160b89c7f2be74ae2962239bd732" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual unsigned short Ogre::AnimationTrack::getNumKeyFrames           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the number of keyframes in this animation. 
<p>

</div>
</div><p>
<a class="anchor" name="f27f57a984619052cca4726cdfd26f3c"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::getKeyFrame" ref="f27f57a984619052cca4726cdfd26f3c" args="(unsigned short index) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a>* Ogre::AnimationTrack::getKeyFrame           </td>
          <td>(</td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>index</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at the specified index. 
<p>

</div>
</div><p>
<a class="anchor" name="55533ed5218c6d423e9443afa2580f5a"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::getKeyFramesAtTime" ref="55533ed5218c6d423e9443afa2580f5a" args="(const TimeIndex &amp;timeIndex, KeyFrame **keyFrame1, KeyFrame **keyFrame2, unsigned short *firstKeyIndex=0) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> Ogre::AnimationTrack::getKeyFramesAtTime           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>timeIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> **&nbsp;</td>
          <td class="paramname"> <em>keyFrame1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> **&nbsp;</td>
          <td class="paramname"> <em>keyFrame2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short *&nbsp;</td>
          <td class="paramname"> <em>firstKeyIndex</em> = <code>0</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the 2 <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> objects which are active at the time given, and the blend value between them. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>At any point in time in an animation, there are either 1 or 2 keyframes which are 'active', 1 if the time index is exactly on a keyframe, 2 at all other times i.e. the keyframe before and the keyframe after. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>This method returns those keyframes given a time index, and also returns a parametric value indicating the value of 't' representing where the time index falls between them. E.g. if it returns 0, the time index is exactly on keyFrame1, if it returns 0.5 it is half way between keyFrame1 and keyFrame2 etc. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>timeIndex</em>&nbsp;</td><td>The time index. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>keyFrame1</em>&nbsp;</td><td>Pointer to a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> pointer which will receive the pointer to the keyframe just before or at this time index. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>keyFrame2</em>&nbsp;</td><td>Pointer to a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> pointer which will receive the pointer to the keyframe just after this time index. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>firstKeyIndex</em>&nbsp;</td><td>Pointer to an unsigned short which, if supplied, will receive the index of the 'from' keyframe incase the caller needs it. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>Parametric value indicating how far along the gap between the 2 keyframes the timeIndex value is, e.g. 0.0 for exactly at 1, 0.25 for a quarter etc. By definition the range of this value is: 0.0 &lt;= returnValue &lt; 1.0 . </dd></dl>

</div>
</div><p>
<a class="anchor" name="4517a1b16d6cb601754d98841bb4d7d6"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::createKeyFrame" ref="4517a1b16d6cb601754d98841bb4d7d6" args="(Real timePos)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a>* Ogre::AnimationTrack::createKeyFrame           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>timePos</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a new <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> and adds it to this animation at the given time index. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>It is better to create KeyFrames in time order. Creating them out of order can result in expensive reordering processing. Note that a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at time index 0.0 is always created for you, so you don't need to create this one, just access it using getKeyFrame(0); </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>this method will always create a keyframe even if the track already has a keyframe at the given time position. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>timePos</em>&nbsp;</td><td>The time from which this <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> will apply. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="3e1ccd99179d804992a5224fe811c2dd"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::removeKeyFrame" ref="3e1ccd99179d804992a5224fe811c2dd" args="(unsigned short index)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::AnimationTrack::removeKeyFrame           </td>
          <td>(</td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>index</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Removes a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> by it's index. 
<p>

</div>
</div><p>
<a class="anchor" name="c8f7b83d742998ed46c8cdb10e404df6"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::removeAllKeyFrames" ref="c8f7b83d742998ed46c8cdb10e404df6" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::AnimationTrack::removeAllKeyFrames           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Removes all the KeyFrames from this track. 
<p>

</div>
</div><p>
<a class="anchor" name="715b6d025247c4857a5deba9376ae48c"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::_keyFrameDataChanged" ref="715b6d025247c4857a5deba9376ae48c" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::AnimationTrack::_keyFrameDataChanged           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data. 
<p>

<p>Reimplemented in <a class="el" href="classOgre_1_1NodeAnimationTrack.html#c63ec3b7f27897f2223aca60f4c90422">Ogre::NodeAnimationTrack</a>.</p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00197">197</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="7aab09df8cf0fea5b1a53df263b9e2c1"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::_collectKeyFrameTimes" ref="7aab09df8cf0fea5b1a53df263b9e2c1" args="(std::vector&lt; Real &gt; &amp;keyFrameTimes)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::AnimationTrack::_collectKeyFrameTimes           </td>
          <td>(</td>
          <td class="paramtype">std::vector&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; &amp;&nbsp;</td>
          <td class="paramname"> <em>keyFrameTimes</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method to collect keyframe times, in unique, ordered format. 
<p>

</div>
</div><p>
<a class="anchor" name="6f341ad134c0254f15a0cba2bbae4097"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::_buildKeyFrameIndexMap" ref="6f341ad134c0254f15a0cba2bbae4097" args="(const std::vector&lt; Real &gt; &amp;keyFrameTimes)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::AnimationTrack::_buildKeyFrameIndexMap           </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; &amp;&nbsp;</td>
          <td class="paramname"> <em>keyFrameTimes</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method to build keyframe time index map to translate global lower bound index to local lower bound index. 
<p>

</div>
</div><p>
<a class="anchor" name="4e61fb2e00abd26a854d122452cb21a0"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::populateClone" ref="4e61fb2e00abd26a854d122452cb21a0" args="(AnimationTrack *clone) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::AnimationTrack::populateClone           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1AnimationTrack.html">AnimationTrack</a> *&nbsp;</td>
          <td class="paramname"> <em>clone</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [protected, virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method for clone implementation. 
<p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="2ac916da1e92895527b816f1da170759"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::mAnimationType" ref="2ac916da1e92895527b816f1da170759" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#9046e6e0d12c46c57a9056987e9d158e">VertexAnimationType</a> <a class="el" href="classOgre_1_1VertexAnimationTrack.html#2ac916da1e92895527b816f1da170759">Ogre::VertexAnimationTrack::mAnimationType</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<a class="el" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a> type. 
<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00531">531</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="146021bbee13fee93a93bd8ef913d77a"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::mTargetVertexData" ref="146021bbee13fee93a93bd8ef913d77a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a>* <a class="el" href="classOgre_1_1VertexAnimationTrack.html#146021bbee13fee93a93bd8ef913d77a">Ogre::VertexAnimationTrack::mTargetVertexData</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Target to animate. 
<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00533">533</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="719e33971eaf3ae6b4f9bc603c94595c"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::mTargetMode" ref="719e33971eaf3ae6b4f9bc603c94595c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexAnimationTrack.html#8428fcdefb79b2dd650b22968a3e8134">TargetMode</a> <a class="el" href="classOgre_1_1VertexAnimationTrack.html#719e33971eaf3ae6b4f9bc603c94595c">Ogre::VertexAnimationTrack::mTargetMode</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Mode to apply. 
<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00535">535</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="8a9bee08f6fa537fc0bcfcee2423775c"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::mKeyFrames" ref="8a9bee08f6fa537fc0bcfcee2423775c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1AnimationTrack.html#501aac9ae307fd6813a31792404cf770">KeyFrameList</a> <a class="el" href="classOgre_1_1AnimationTrack.html#8a9bee08f6fa537fc0bcfcee2423775c">Ogre::AnimationTrack::mKeyFrames</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00217">217</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="ea479089005d263e195cde7e4faca665"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::mParent" ref="ea479089005d263e195cde7e4faca665" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Animation.html">Animation</a>* <a class="el" href="classOgre_1_1AnimationTrack.html#ea479089005d263e195cde7e4faca665">Ogre::AnimationTrack::mParent</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00218">218</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="5fb5dc3c01452aa4d542981485d15080"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::mHandle" ref="5fb5dc3c01452aa4d542981485d15080" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned short <a class="el" href="classOgre_1_1AnimationTrack.html#5fb5dc3c01452aa4d542981485d15080">Ogre::AnimationTrack::mHandle</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00219">219</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="2c053bac1d2eedc782eb24b79dc79a21"></a><!-- doxytag: member="Ogre::VertexAnimationTrack::mKeyFrameIndexMap" ref="2c053bac1d2eedc782eb24b79dc79a21" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1AnimationTrack.html#27b9b55f9a560e3b7c83f0d47676fc51">KeyFrameIndexMap</a> <a class="el" href="classOgre_1_1AnimationTrack.html#2c053bac1d2eedc782eb24b79dc79a21">Ogre::AnimationTrack::mKeyFrameIndexMap</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00223">223</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:49:07 2008
</p>
</body>
</html>
